#include <assert.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "grader.h"

#define N MaxN
#define K (N * N)

static char F[N][N];
static char _F[N][N];

static int _x[K], _y[K];
static char _v[K];
static int pt = 0;

static int n;

void ToggleDeflectors()
{
    int i;
    for (i = 0; i < pt; i++)
        F[_y[i]][_x[i]] ^= '/' ^ '\\';
}

void ResetBox()
{
    int i;
    for (i = 0; i < pt; i++)
        F[_y[i]][_x[i]] = _v[i];
}

static void internal_init()
{
    int i, j;
    scanf("%s\n", F[0]);
    n = strlen(F[0]);
    for (i = 1; i < n; i++)
        scanf("%s\n", F[i]);
    memcpy(_F, F, sizeof(F));
    for (i = 0; i < n; i++)
        for (j = 0; j < n; j++)
            if (F[i][j] != '.')
                _x[pt] = j, _y[pt] = i, _v[pt] = F[i][j], pt++;
}

static int vy[] = {1, 0, -1, 0};
static int vx[] = {0, -1, 0, 1};

// 0 - down, 1 - left, 2 - up, 3 - right

int throwBall(int h,int s,int* newh,int* news)
{
    if (!(1 <= s && s <= 4)){
        printf("PE\n");
        printf("Invalid side : %d\n",s);
        exit(0);
    }
    if (!(1 <= h && h <= n)){
        printf("PE\n");
        printf("Invalid hole : %d\n",h);
        exit(0);
    }
    --s;
    --h;
    int x, y;
    if (s % 2)
        y = h, x = (s == 1) * (n - 1);
    else
        x = h, y = (s == 2) * (n - 1);
    int v = s;
    int count = 0;
    while (1)
    {
        if (F[y][x] != '.')
        {
            v = ((F[y][x] == '/') ?
            // 0 - 1, 2 - 3
                1 ^ v :
            // 0 - 3, 1 - 2
                3 ^ v
            );
            count++;
            F[y][x] ^= ('/' ^ '\\');
        }
        y += vy[v];
        x += vx[v];
        if (y < 0 || x < 0 || y >= n || x >= n)
            break;
    }
    h = (v % 2) ? y : x;
    h++;
    s = 2 ^ v;
    s++;
    *news = s;
    *newh = h;
    return count;
}

static char pans[N][N];

int notFound;

static void CheckAnswer()
{
    int i,j;
    ResetBox();
    for (i = 0; i < n; i++)
        for (j = 0; j < n; j++){
            if (pans[i][j] != F[i][j] && pans[i][j] != '?'){
                puts("WA");
                printf("Position (%d,%d) doesn't match",i+1,j+1);
                exit(0);
            }
            else if (pans[i][j] == '?')
                notFound++;
        }
}


int _main(solveFunction solve){
    internal_init();
    solve(n,pans);
    CheckAnswer();
    puts("OK");
    printf("%d\n",notFound);
    return 0;
}
